""" File with the addon ui panels """
import bpy


class OBJECT_PT_f2f_projection_panel(bpy.types.Panel):
    # bl_parent_id = "VIEW3D_PT_f2f_options_panel"
    bl_idname = 'OBJECT_PT_f2f_projection_panel'
    # bl_label = 'PROJECTIONS'
    bl_category = 'f2F'
    bl_label = 'face2FACE PROJECTIONS'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'

    @classmethod
    def poll(cls, context):
        if context.window_manager.face2face.is_modal_active:
            return False
        if not context.window_manager.face2face.is_active:
            return False
        if context.active_object is None:
            return False
        if len(context.active_object.projections) <= 0 and context.active_object.belongs_to == "NOTHING":
            return False

        return True

    def draw(self, context):
        layout = self.layout
        if not context.window_manager.face2face.is_modal_active:

            if context.window_manager.face2face.is_active:
                if not context.active_object is None:
                    if len(context.active_object.projections) > 0:
                        layout.label(text="Active object is Target of:")
                    for projection in context.active_object.projections:
                        # col = layout.column()
                        box = layout.box()

                        row_header = box.split(factor=0.9, align=True)
                        row_header.label(text=projection.projection_name.replace(
                            context.active_object.name+'.', ''))
                        colhd = row_header.column()
                        colhd.alert = True
                        buttonhd = colhd.operator(
                            "object.delete_face2face_projection", text="x")
                        buttonhd.projection_x_name = projection.projection_name
                        buttonhd.data_only = not context.window_manager.face2face.delete_objects_also
                        buttonhd.target_also = context.window_manager.face2face.delete_target_object_also

                        row = box.split(factor=0.5, align=True)
                        col = row.column()
                        button = col.operator(
                            "object.reactivate_face2face_projection", text="reactivate")
                        button.reactivation_name = projection.projection_name
                        col = row.column()
                        button = col.operator(
                            "object.copy_face2face_projection", text="copy")
                        button.copy_projection_name = projection.projection_name

                    if context.active_object.belongs_to != "NOTHING":
                        layout.label(text="Active object is part of:")
                        # col = layout.column()
                        box = layout.box()
                        # box.label(text=context.active_object.belongs_to)
                        # row = box.split(factor=0.9, align=True)  # row()
                        row_header = box.split(factor=0.9, align=True)
                        row_header.label(text=context.active_object.belongs_to)
                        #col = row_header.column()
                        """ button = col.operator(
                            "object.reactivate_face2face_projection", text="reactivate"
                        button.reactivation_name=context.active_object.belongs_to
 """
                        col2 = row_header.column()
                        col2.alert = True
                        buttond = col2.operator(
                            "object.delete_face2face_projection", text="x")
                        buttond.projection_x_name = context.active_object.belongs_to
                        buttond.data_only = not context.window_manager.face2face.delete_objects_also
                        buttond.target_also = context.window_manager.face2face.delete_target_object_also

                        row = box.split(factor=0.5, align=True)
                        col = row.column()
                        button = col.operator(
                            "object.reactivate_face2face_projection", text="reactivate")
                        button.reactivation_name = context.active_object.belongs_to
                        col = row.column()
                        button = col.operator(
                            "object.copy_face2face_projection", text="copy")
                        button.copy_projection_name = context.active_object.belongs_to


def register():
    bpy.utils.register_class(OBJECT_PT_f2f_projection_panel)


def unregister():
    bpy.utils.unregister_class(OBJECT_PT_f2f_projection_panel)
